//
//  BusquedaController.m
//  Filmoteca
//
//  Created by Miguel Angel Lozano on 28/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "UABusquedaViewController.h"

#import "UAPelicula.h"

@implementation UABusquedaViewController

@synthesize peliculas = _peliculas;
@synthesize peliculasFiltradas = _peliculasFiltradas;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithNibName: @"UABusquedaView" bundle:nil];
    if (self) {
        // Custom initialization
        self.title = @"Busqueda";
        self.tabBarItem.image = [UIImage imageNamed:@"magnifier"];
        
        UAPelicula *pelicula1 = [[UAPelicula alloc] initWithTitulo:@"El Resplandor"];
        pelicula1.cartel = [UIImage imageNamed:@"resplandor.jpg"];
        UAPelicula *pelicula2 = [[UAPelicula alloc] initWithTitulo:@"Malditos Bastardos"];
        pelicula2.cartel = [UIImage imageNamed:@"bastardos.jpg"];
        pelicula2.calificacion = NR18;
        UAPelicula *pelicula3 = [[UAPelicula alloc] initWithTitulo:@"Robocop"];
        pelicula3.cartel = [UIImage imageNamed:@"robocop.jpg"];
        pelicula3.calificacion = NR13;
        
        self.peliculas = [NSArray arrayWithObjects:pelicula1, pelicula2, pelicula3, nil];
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];

    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    if(tableView == self.searchDisplayController.searchResultsTableView) {
        return [self.peliculasFiltradas count];
    } else {
        return [self.peliculas count];        
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    // Configure the cell...
    if(tableView == self.searchDisplayController.searchResultsTableView) {
        UAPelicula *pelicula = [self.peliculasFiltradas objectAtIndex: indexPath.row];
        cell.textLabel.text = pelicula.titulo;
    } else {
        UAPelicula *pelicula = [self.peliculas objectAtIndex: indexPath.row];
        cell.textLabel.text = pelicula.titulo;
    }
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Search display delegate

- (BOOL)searchDisplayController:(UISearchDisplayController *)controller shouldReloadTableForSearchString:(NSString *)searchString {
    
    NSMutableArray *seleccionadas = [NSMutableArray arrayWithCapacity: [self.peliculas count]];
    for(UAPelicula *pelicula in self.peliculas) {
        NSRange rango = [pelicula.titulo rangeOfString: searchString options:NSCaseInsensitiveSearch];
        if(rango.location != NSNotFound) {
            [seleccionadas addObject: pelicula];
        }
    }
    
    self.peliculasFiltradas = seleccionadas;
    
    return YES;
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
}

@end
